/*
=================================================

				DirectDraw sub-system
			Justin Reynen (Mr.Oreo) 1999

	DirectDraw will be used for tesing, and is
good enough to just plot pixels and stuff.

=================================================
*/

#include "dd.h"

LPDIRECTDRAW lpdd;
LPDIRECTDRAWSURFACE sPrimary; //Primary surface
LPDIRECTDRAWSURFACE sBack; //Back buffer
DDSURFACEDESC ddsd;
DDBLTFX bltfx;
DDSCAPS ddscaps;




//Starts up DirectDraw

int DirectDrawInit(HWND handle)
{
	
	DirectDrawCreate(NULL, &lpdd, NULL);

	lpdd->SetCooperativeLevel(handle, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN | DDSCL_ALLOWREBOOT | DDSCL_ALLOWMODEX);

	lpdd->SetDisplayMode(800, 600, 16);

	
	ddsd.dwSize = sizeof(ddsd);
	ddsd.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
	ddsd.dwWidth = 800;
	ddsd.dwHeight = 600;
	ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE | DDSCAPS_FLIP | DDSCAPS_COMPLEX;
	ddsd.dwBackBufferCount = 1; 

	lpdd->CreateSurface(&ddsd, &sPrimary, NULL);

	memset(&ddscaps, 0, sizeof(ddscaps));
	
	ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
	
	sPrimary->GetAttachedSurface(&ddscaps, &sBack);

return(0);
}

int DirectDrawShutdown(void)
{

	sPrimary->Release();


return(0);
}

int DDPutPixel(int x, int y, USHORT color)
{
	USHORT* vidMem = 0;

	memset(&ddsd, 0, sizeof(ddsd));

	ddsd.dwSize = sizeof(ddsd);

	sBack->Lock(NULL, &ddsd, DDLOCK_WAIT | DDLOCK_SURFACEMEMORYPTR, NULL);

	vidMem = (USHORT*)ddsd.lpSurface;

	*(vidMem +(x + (600 - y) * ddsd.lPitch/2)) = color;

	sBack->Unlock(ddsd.lpSurface);
return(0);
}

int ClearScreen()
{
	memset(&bltfx, 0, sizeof(bltfx));
	bltfx.dwSize = sizeof(bltfx);

	bltfx.dwFillColor = 0;

	sBack->Blt(NULL,NULL,NULL,DDBLT_COLORFILL | DDBLT_WAIT, &bltfx);

return(0);
}

int Flip()
{
	sBack->Flip(NULL, DDFLIP_WAIT);
return(0);
}




