/*
===============================================================================
						Bezier Spline Experiments
						Justin Reynen (Mr.Oreo) 1999

	I want to try making some basic curves using Quadratic and Cubic
Bezier splines, whose functions are derived from the Bersteins basis
function.

  

DirectDraw does all the work :)

===============================================================================
*/

#include <WinInit.h>
#include "dd.h"

#define B1(t) (t*t)  //First Derived function from Bernsteins basis
#define B2(t) (2*t*(1-t)) //Second Derived function
#define B3(t) ((1-t)*(1-t)) //Third Derived Function

#define POINT_SPEED 4

void DrawControlPoint(double x, double y, USHORT color);


typedef struct sPoint
{
	double x;
	double y;

} POINT2D;




int Game_Init()
{
	DirectDrawInit(main_window_handle);
	
	
	
return(0);
}	
	
int Game_Main()
{
	POINT2D cp[3]; //cp stands for control points

	FILE* fout;

	double distance; //how long are we going to travel each loop
	double detailBias; // how many points on the spline
	double i; //a counter

	double x,y; //our x and y points

	detailBias = 50;

	distance = 1 / detailBias;

	cp[0].x = 200; //800 / 4
	cp[0].y = 300; //600 / 2

	cp[1].x = 400; //800 / 2
	cp[1].y = 450; //(600 / 4) * 3

	cp[2].x = 600; //(800 / 4) * 3
	cp[2].y = 300; //600 / 2

	
		
	do
	{
	
		//ClearScreen();
		do
		{
				//Draw the spline
				
				x = cp[0].x*B1(i) + cp[1].x*B2(i) + cp[2].x*B3(i);
				y = cp[0].y*B1(i) + cp[1].y*B2(i) + cp[2].y*B3(i);
				
				
				DDPutPixel(x,y,RGB16(int(31*i),int(31*i),int(31 - (31*i))));
				
				i = i + distance; // Recompute Distance


				

				

		
		}while( i <= 1 );

	//Recalculate all the control points
				if(KEY_DOWN(VK_LEFT) && (cp[0].x - POINT_SPEED >= 0) && !KEY_DOWN(VK_SHIFT) && !KEY_DOWN(VK_CONTROL))
					cp[0].x += -POINT_SPEED;
				if(KEY_DOWN(VK_RIGHT) && (cp[0].x + POINT_SPEED <= 800) && !KEY_DOWN(VK_SHIFT) && !KEY_DOWN(VK_CONTROL))
					cp[0].x += POINT_SPEED;
				if(KEY_DOWN(VK_UP) && (cp[0].y + POINT_SPEED <= 600) && !KEY_DOWN(VK_SHIFT) && !KEY_DOWN(VK_CONTROL))
					cp[0].y += POINT_SPEED;
				if(KEY_DOWN(VK_DOWN) && (cp[0].y - POINT_SPEED >= 0) && !KEY_DOWN(VK_SHIFT) && !KEY_DOWN(VK_CONTROL))
					cp[0].y += -POINT_SPEED;

				if(KEY_DOWN(VK_LEFT) && (cp[1].x - POINT_SPEED >= 0) && KEY_DOWN(VK_SHIFT))
					cp[1].x += -POINT_SPEED;
				if(KEY_DOWN(VK_RIGHT) && (cp[1].x + POINT_SPEED <= 800) && KEY_DOWN(VK_SHIFT))
					cp[1].x += POINT_SPEED;
				if(KEY_DOWN(VK_UP) && (cp[1].y + POINT_SPEED <= 600) && KEY_DOWN(VK_SHIFT))
					cp[1].y += POINT_SPEED;
				if(KEY_DOWN(VK_DOWN) && (cp[1].y - POINT_SPEED >= 0) && KEY_DOWN(VK_SHIFT))
					cp[1].y += -POINT_SPEED;

				if(KEY_DOWN(VK_LEFT) && (cp[2].x - POINT_SPEED >= 0) && KEY_DOWN(VK_CONTROL))
					cp[2].x += -POINT_SPEED;
				if(KEY_DOWN(VK_RIGHT) && (cp[2].x + POINT_SPEED <= 800) && KEY_DOWN(VK_CONTROL))
					cp[2].x += POINT_SPEED;
				if(KEY_DOWN(VK_UP) && (cp[2].y + POINT_SPEED <= 600) && KEY_DOWN(VK_CONTROL))
					cp[2].y += POINT_SPEED;
				if(KEY_DOWN(VK_DOWN) && (cp[2].y - POINT_SPEED >= 0) && KEY_DOWN(VK_CONTROL))
					cp[2].y += -POINT_SPEED;

				//Update the detail bias
				if(KEY_DOWN(VK_F1))
					detailBias += 1;

				if(KEY_DOWN(VK_F2))
					detailBias -= 1;

				if(detailBias <= 0)
					detailBias = 1;

				
				//Re-Calculate our traveling distance
				distance = 1 / detailBias;
				
				//Draw the control points now
				DrawControlPoint(cp[0].x,cp[0].y, RGB16(31,0,0));
				DrawControlPoint(cp[1].x,cp[1].y, RGB16(31,31,31));
				DrawControlPoint(cp[2].x,cp[2].y, RGB16(31,0,0));

	i = 0;
	//Flip();
	
	

	}while(!KEY_DOWN(VK_ESCAPE));
			
		


return(0);
}

int Game_Shutdown()
{
	DirectDrawShutdown();
	

return(0);
}

void DrawControlPoint(double x, double y, USHORT color)
{
	DDPutPixel(x+1,y+1,color);
	DDPutPixel(x-1,y-1,color);
	DDPutPixel(x+1,y-1,color);
	DDPutPixel(x-1,y+1,color);
	DDPutPixel(x,y,color);


}


